window.Gleam.initSearch([{"doc":"puddle","title":"puddle","content":"![puddle](https://raw.githubusercontent.com/massivefermion/puddle/main/banner.jpg)\n\n[![Package Version](https://img.shields.io/hexpm/v/puddle)](https://hex.pm/packages/puddle)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/puddle/)\n\n# puddle\n\nA resource pool manager for gleam\n\n## &lt;img width=32 src=&quot;https://raw.githubusercontent.com/massivefermion/puddle/main/icon.png&quot;&gt; Quick start\n\n```sh\ngleam test  # Run the tests\ngleam shell # Run an Erlang shell\n```\n\n## &lt;img width=32 src=&quot;https://raw.githubusercontent.com/massivefermion/puddle/main/icon.png&quot;&gt; Installation\n\nThis package can be added to your Gleam project:\n\n```sh\ngleam add puddle\n```\n\nand its documentation can be found at &lt;https://hexdocs.pm/puddle&gt;.\n\n## &lt;img width=32 src=&quot;https://raw.githubusercontent.com/massivefermion/puddle/main/icon.png&quot;&gt; Usage\n\n```gleam\nimport gleam/int\nimport gleam/otp/task\nimport puddle\n\npub fn main() {\n  let assert Ok(manager) = puddle.start(4, fn() { Ok(int.random(1024, 8192)) })\n\n  let fun = fn(n) { n * 2 }\n\n  let t1 =\n    task.async(fn() {\n      use r &lt;- puddle.apply(manager, fun, 32)\n      r\n    })\n\n  let t2 =\n    task.async(fn() {\n      use r &lt;- puddle.apply(manager, fun, 32)\n      r\n    })\n\n  task.await(t1, 32)\n  task.await(t2, 32)\n}\n```","url":"index.html"},{"doc":"puddle","title":"ManagerMessage","content":"pub opaque type ManagerMessage(resource_type, result_type)\n\n\nSynonyms:\npuddle.ManagerMessage\npuddle ManagerMessage","url":"puddle.html#ManagerMessage"},{"doc":"puddle","title":"ResourceMessage","content":"pub opaque type ResourceMessage(resource_type, result_type)\n\n\nSynonyms:\npuddle.ResourceMessage\npuddle ResourceMessage","url":"puddle.html#ResourceMessage"},{"doc":"puddle","title":"apply","content":"pub fn apply(\n  manager: Subject(ManagerMessage(a, b)),\n  fun: fn(a) -&gt; b,\n  timeout: Int,\n  rest: fn(Result(b, Nil)) -&gt; Result(c, Nil),\n) -&gt; Result(c, Nil)\n checks-out a resource, applies the function and then checks-in the resource\nSynonyms:\npuddle.apply\npuddle apply","url":"puddle.html#apply"},{"doc":"puddle","title":"shutdown","content":"pub fn shutdown(\n  manager: Subject(ManagerMessage(a, b)),\n  resource_shutdown_function: fn(a) -&gt; Nil,\n) -&gt; Nil\n\nSynonyms:\npuddle.shutdown\npuddle shutdown","url":"puddle.html#shutdown"},{"doc":"puddle","title":"start","content":"pub fn start(\n  size: Int,\n  resource_creation_function: fn() -&gt; Result(a, Nil),\n) -&gt; Result(Subject(ManagerMessage(a, b)), StartError)\n\nSynonyms:\npuddle.start\npuddle start","url":"puddle.html#start"},{"doc":"puddle","title":"puddle","content":"","url":"puddle.html"}]);